"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChromosomeBase = void 0;
class ChromosomeBase {
    constructor(_length) {
        this.fitness = undefined;
        // eslint-disable-next-line no-magic-numbers
        if (_length < 2) {
            throw new Error('Too short.');
        }
        this.acids = new Array(_length);
    }
    createFromAcids(acids) {
        this.acids = [...acids];
    }
    get length() {
        return this.acids.length;
    }
    getAcid(index) {
        return this.acids[index];
    }
    setAcid(index, acid) {
        this.acids[index] = acid;
    }
    generateAcids() {
        [...Array(this.length).keys()].forEach(index => this.setAcid(index, this.generateAcid(index)));
    }
    clone() {
        const clone = this.createNew();
        clone.copyFrom(this);
        return clone;
    }
    copyFrom(from) {
        if (from.length !== this.length) {
            throw new Error('Length is not same.');
        }
        // eslint-disable-next-line no-magic-numbers
        for (let index = this.length; --index >= 0;) {
            this.acids[index] = from.getAcid(index);
        }
        this.fitness = from.fitness;
        this.performCopyFrom(from);
    }
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    performCopyFrom(from) {
        // override if required
    }
    mutation(index) {
        this.acids[index] = this.generateAcid(index);
    }
}
exports.ChromosomeBase = ChromosomeBase;
//# sourceMappingURL=ChromosomeBase.js.map