"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CrossoverBase = void 0;
class CrossoverBase {
    constructor(_parentsNumber, _childrenNumber) {
        this._parentsNumber = _parentsNumber;
        this._childrenNumber = _childrenNumber;
    }
    get parentsNumber() {
        return this._parentsNumber;
    }
    get childrenNumber() {
        return this._childrenNumber;
    }
    async cross(parents, probability) {
        if (parents.length !== this.parentsNumber) {
            throw new Error('Length is not same.');
        }
        const offspring = await this.performCross(parents, probability);
        if (offspring.length !== this.childrenNumber) {
            throw new Error('Length is not same.');
        }
        return offspring;
    }
}
exports.CrossoverBase = CrossoverBase;
//# sourceMappingURL=CrossoverBase.js.map